## nomacs 3.8.0+dfsg

=== CMakeLists.txt ===

# check cmake requirements
cmake_minimum_required(VERSION 2.8)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)

	IF(CMAKE_VERSION VERSION_GREATER 2.8.10)
		cmake_policy(SET CMP0020 NEW)	# qt warnings
	ENDIF()
	IF(CMAKE_VERSION VERSION_GREATER 2.8.12.9)
		cmake_policy(SET CMP0043 NEW)	# COMPILE_DEFINITIONS_<CONFIG> warnings
	ENDIF()
endif(COMMAND cmake_policy)

######################## begin of project
project(nomacs)

# needed for soname
set(NOMACS_VERSION_MAJOR 3)
set(NOMACS_VERSION_MINOR 8)
set(NOMACS_VERSION_PATCH 0)
set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})

# Codecov
if(CMAKE_COMPILER_IS_GNUCXX)
    include("cmake/CodeCoverage.cmake")
    setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
endif()

if(CMAKE_CL_64)
	SET(NMC_ARCHITECTURE "x64")
else()
	SET(NMC_ARCHITECTURE "x86")
endif()

add_definitions(-DNOMACS_VERSION="${NOMACS_VERSION}")

set(BINARY_NAME ${CMAKE_PROJECT_NAME})
set(NOMACS_BUILD_DIRECTORY ${CMAKE_BINARY_DIR})

# include macros needed
include("cmake/Utils.cmake")

# different compile options
option(ENABLE_OPENCV "Compile with Opencv (needed for RAW and TIFF)" ON)
option(ENABLE_RAW "Compile with raw images support (libraw)" ON)
option(ENABLE_TIFF "Compile with multi-layer tiff" ON)
option(ENABLE_QT_DEBUG "Disable Qt Debug Messages" ON)
option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
option(ENABLE_TRANSLATIONS "Compile Translations" OFF)
option(ENABLE_READ_BUILD "Build nomacs for READ" OFF)
option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)

if(APPLE)
	option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" OFF)
	message(STATUS "QuaZip disabled because you are using a mac")
else()
	option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
endif()

if(${ENABLE_READ_BUILD}) # cannot be incorporated into if one line above
	# set output path when building for READ
	if(MSVC)
		SET(CMAKE_LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})
		SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<CONFIGURATION>)
		SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<CONFIGURATION>)
		message(STATUS "READ build turned on...")
	else()
		set(NOMACS_BUILD_DIRECTORY ${CMAKE_BINARY_DIR}/READ)
		SET(CMAKE_LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/READ)
		SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/READ)
		SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/READ)
	endif()
endif()

if (ENABLE_QUAZIP)
	message(STATUS "QuaZip enabled")
endif()

# load paths from the user file if exists
if(EXISTS ${CMAKE_SOURCE_DIR}/CMakeUser.cmake)
	include(${CMAKE_SOURCE_DIR}/CMakeUser.cmake)
endif()

include(CheckCXXCompilerFlag)
#CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
#if(COMPILER_SUPPORTS_CXX14)
#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
#else
if(COMPILER_SUPPORTS_CXX11)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
elseif(NOT MSVC)
	message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	# Codecov
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage")
endif()

# find Qt
NMC_FINDQT()

if (!ENABLE_QT_DEBUG)
	message (STATUS "disabling qt debug messages")
	add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Win.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Mac.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
endif()

file(GLOB NOMACS_EXE_SOURCES "src/*.cpp")
file(GLOB NOMACS_EXE_HEADERS "src/*.h")

# gui
file(GLOB GUI_SOURCES "src/DkGui/*.cpp")
file(GLOB GUI_HEADERS "src/DkGui/*.h")

# core
file(GLOB CORE_SOURCES "src/DkCore/*.cpp")
file(GLOB CORE_HEADERS "src/DkCore/*.h")

# gather information for building
include_directories (
	${EXIV2_INCLUDE_DIRS}
	${LIBRAW_INCLUDE_DIRECTORY}
	${CMAKE_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkGui
	${TIFF_INCLUDE_DIR}
	${TIFF_CONFIG_DIR}
	${QUAZIP_INCLUDE_DIRECTORY}
	# ${ZLIB_INCLUDE_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libqpsd
)

if (APPLE) # todo: somehow add this to Mac.cmake or MacBuildTarget.cmake
	SET (NOMACS_SOURCES ${NOMACS_SOURCES} macosx/nomacs.icns)
endif (APPLE)

IF(NOT ENABLE_PLUGINS)
	LIST(REMOVE_ITEM GUI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.cpp)
	LIST(REMOVE_ITEM GUI_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.h)
ENDIF(NOT ENABLE_PLUGINS)


set(NOMACS_FORMS src/nomacs.ui)

set(NOMACS_RESOURCES src/nomacs.qrc)

file(GLOB NOMACS_TRANSLATIONS "translations/*.ts")

QT5_ADD_RESOURCES(NOMACS_RCC ${NOMACS_RESOURCES})

if (${ENABLE_TRANSLATIONS})
	QT5_ADD_TRANSLATION(NOMACS_QM ${NOMACS_TRANSLATIONS})
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MacBuildTarget.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
endif()

NMC_INSTALL()

#debug for printing out all variables
# get_cmake_property(_variableNames VARIABLES)
# foreach (_variableName ${_variableNames})
#     message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()

message(STATUS "opencv libs: ${OpenCV_LIBS}")

if(UNIX AND ENABLE_PLUGINS)
	if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
		SET(NOMACS_FOUND true)
		SET(NOMACS_VARS_ALREADY_SET true)
		add_subdirectory(plugins)
	else()
		message(WARNING "plugins directory not found, not building plugins. You have to check out the nomacs-plugins git to the 'plugins' folder if you want to build them")
	endif()
endif()

# status
MESSAGE(STATUS "")
MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <http://www.nomacs.org>")
MESSAGE(STATUS "")

option(ENABLE_READ_BUILD "Build nomacs for READ" OFF)
option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)

IF(OpenCV_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. NO")
ENDIF()

IF(LIBRAW_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. NO")
ENDIF()

IF(ENABLE_TIFF)
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... NO")
ENDIF()

IF(ENABLE_PLUGINS)
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. NO")
ENDIF()
MESSAGE(STATUS "----------------------------------------------------------------------------------")

=== debian/changelog ===
nomacs (3.8.0+dfsg-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 22 Nov 2017 13:05:04 -0800

=== debian/control ===
Source: nomacs
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
Uploaders: Alf Gaida <agaida@siduction.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Andrew Lee (李健秋) <ajqlee@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake (>= 3.0.2),
               lcov,
               libexiv2-dev,
               liblcms2-dev,
               libopencv-dev,
               libqt5svg5-dev,
               libquazip-dev,
               libraw-dev,
               libtiff5-dev,
               libwebp-dev,
               qt5-qmake,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/nomacs.git/?h=debian/sid
Vcs-Git: https://anonscm.debian.org/git/pkg-lxqt/nomacs.git -b debian/sid
Homepage: http://www.nomacs.org

Package: nomacs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         qt5-image-formats-plugins
Breaks: libnomacscore3 (<< 3.6.1),
        libnomacsgui3 (<< 3.6.1),
        libnomacsloader3 (<< 3.6.1)
Replaces: libnomacscore3 (<< 3.6.1),
          libnomacsgui3 (<< 3.6.1),
          libnomacsloader3 (<< 3.6.1)
Recommends: nomacs-l10n (= ${source:Version})
Description: image viewer with capability of syncing multiple instances
 nomacs is a free image viewer for Windows and Linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on
 the same computer or via LAN is possible. It allows one to compare images
 and spot the differences (e.g. schemes of architects to show the
 progress).

Package: nomacs-l10n
Architecture: all
Multi-Arch: foreign
Section: localization
Depends: ${misc:Depends}
Replaces: nomacs (<< 3.4.1~)
Description: image viewer with capability of syncing multiple instances (data)
 nomacs is a free image viewer for Windows and Linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on
 the same computer or via LAN is possible. It allows one to compare images
 and spot the differences (e.g. schemes of architects to show the
 progress).
 .
 This package provides the nomacs translations.

## nomacs 3.10.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,17 +17,11 @@
 
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
-set(NOMACS_VERSION_MINOR 8)
+set(NOMACS_VERSION_MINOR 10)
 set(NOMACS_VERSION_PATCH 0)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
 
-# Codecov
-if(CMAKE_COMPILER_IS_GNUCXX)
-    include("cmake/CodeCoverage.cmake")
-    setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
-endif()
-
 if(CMAKE_CL_64)
 	SET(NMC_ARCHITECTURE "x64")
 else()
@@ -41,6 +35,8 @@
 
 # include macros needed
 include("cmake/Utils.cmake")
+
+set(QT5_MIN_VERSION 5.2.1)
 
 # different compile options
 option(ENABLE_OPENCV "Compile with Opencv (needed for RAW and TIFF)" ON)
@@ -51,6 +47,13 @@
 option(ENABLE_TRANSLATIONS "Compile Translations" OFF)
 option(ENABLE_READ_BUILD "Build nomacs for READ" OFF)
 option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)
+option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
+
+# Codecov
+if( ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
+    include("cmake/CodeCoverage.cmake")
+    setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
+endif()
 
 if(APPLE)
 	option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" OFF)
@@ -98,7 +101,7 @@
 	message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
 endif()
 
-if(CMAKE_COMPILER_IS_GNUCXX)
+if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
 	# Codecov
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage")
 endif()
@@ -159,7 +162,6 @@
 
 
 set(NOMACS_FORMS src/nomacs.ui)
-
 set(NOMACS_RESOURCES src/nomacs.qrc)
 
 file(GLOB NOMACS_TRANSLATIONS "translations/*.ts")

=== debian/changelog ===
nomacs (3.10.2+dfsg-1) unstable; urgency=medium

  * Cherry-picked new upstream release 3.10.2.

 -- Alf Gaida <agaida@siduction.org>  Sun, 15 Jul 2018 23:40:50 +0200

nomacs (3.10.1+dfsg-1) unstable; urgency=medium

  * Cherry-picked new upstream release 3.10.1.
  * Bumped Standards to 4.1.5
  * Removed no longer needed cmake minimum version
  * Fixed patch version
  * moved ./debian/.gitignore to .
  * Upstream switched back to XDG configuration dirs for linux
    (Closes: #893677)

 -- Alf Gaida <agaida@siduction.org>  Sat, 07 Jul 2018 00:45:16 +0200

nomacs (3.8.1+dfsg-1) unstable; urgency=medium

  * Cherry-picked new upstream release 3.8.1.
  * Bump debhelper dependency to 11~
  * Bumped compat to 11, no changes needed
  * Bumped Standards to 4.1.4
  * Made VCS field canonical
  * Removed some trailing whitespaces from changelog
  * New version fixes the FTBFS (Closes: #896472)
  * Moved source.lintiian-overrides to source/lintian-overrides

 -- Alf Gaida <agaida@siduction.org>  Sun, 22 Apr 2018 18:49:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,27 @@
 Source: nomacs
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-Bugs: mailto: <stevep@mxlinux.org>
-XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
+Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper (>= 10),
-               cmake (>= 3.0.2),
+Build-Depends: debhelper (>= 11~),
+               cmake,
                lcov,
                libexiv2-dev,
                liblcms2-dev,
                libopencv-dev,
                libqt5svg5-dev,
-               libquazip-dev,
+               libquazip5-dev,
                libraw-dev,
                libtiff5-dev,
                libwebp-dev,
                qt5-qmake,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/nomacs.git/?h=debian/sid
-Vcs-Git: https://anonscm.debian.org/git/pkg-lxqt/nomacs.git -b debian/sid
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
+Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
 Homepage: http://www.nomacs.org
 
 Package: nomacs

## nomacs 3.12.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: nomacs
-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                lcov,
                libexiv2-dev,
@@ -19,7 +20,7 @@
                qt5-qmake,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 4.1.5
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
 Homepage: http://www.nomacs.org

## nomacs 3.12.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 
 # check cmake requirements
 cmake_minimum_required(VERSION 2.8)
+
 if(COMMAND cmake_policy)
 	cmake_policy(SET CMP0003 NEW)
 
@@ -17,7 +18,7 @@
 
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
-set(NOMACS_VERSION_MINOR 10)
+set(NOMACS_VERSION_MINOR 12)
 set(NOMACS_VERSION_PATCH 0)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
@@ -43,6 +44,7 @@
 option(ENABLE_RAW "Compile with raw images support (libraw)" ON)
 option(ENABLE_TIFF "Compile with multi-layer tiff" ON)
 option(ENABLE_QT_DEBUG "Disable Qt Debug Messages" ON)
+option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
 option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
 option(ENABLE_TRANSLATIONS "Compile Translations" OFF)
 option(ENABLE_READ_BUILD "Build nomacs for READ" OFF)
@@ -58,8 +60,6 @@
 if(APPLE)
 	option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" OFF)
 	message(STATUS "QuaZip disabled because you are using a mac")
-else()
-	option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
 endif()
 
 if(${ENABLE_READ_BUILD}) # cannot be incorporated into if one line above
@@ -77,13 +77,11 @@
 	endif()
 endif()
 
-if (ENABLE_QUAZIP)
-	message(STATUS "QuaZip enabled")
-endif()
-
 # load paths from the user file if exists
-if(EXISTS ${CMAKE_SOURCE_DIR}/CMakeUser.cmake)
-	include(${CMAKE_SOURCE_DIR}/CMakeUser.cmake)
+if (EXISTS ${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
+	include(${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
+elseif(MSVC)
+	message(WARNING "Could not find CMakeUserPaths.cmake - please use this file to specify your install directories (see CMakeUserPathsGit.cmake)")
 endif()
 
 include(CheckCXXCompilerFlag)
@@ -146,9 +144,10 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/src/DkGui
 	${TIFF_INCLUDE_DIR}
 	${TIFF_CONFIG_DIR}
-	${QUAZIP_INCLUDE_DIRECTORY}
-	# ${ZLIB_INCLUDE_DIRS}
+	${QUAZIP_INCLUDE_DIR}
+	${QUAZIP_ZLIB_INCLUDE_DIR}
 	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libqpsd
+	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/drif
 )
 
 if (APPLE) # todo: somehow add this to Mac.cmake or MacBuildTarget.cmake
@@ -185,28 +184,46 @@
 
 NMC_INSTALL()
 
+NMC_COPY_FILES()
+
 #debug for printing out all variables
 # get_cmake_property(_variableNames VARIABLES)
 # foreach (_variableName ${_variableNames})
 #     message(STATUS "${_variableName}=${${_variableName}}")
 # endforeach()
 
-message(STATUS "opencv libs: ${OpenCV_LIBS}")
-
 if(UNIX AND ENABLE_PLUGINS)
-	if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
-		SET(NOMACS_FOUND true)
-		SET(NOMACS_VARS_ALREADY_SET true)
-		add_subdirectory(plugins)
+
+	if (NOT DEFINED ${PLUGINS_DIR})
+		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
+		message(STATUS "setting plugins dir")
+	else ()
+		message(STATUS "${PLUGINS_DIR} is defined")
+	endif()
+
+	if (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
+		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
+	elseif (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
+		# set the snapcraft dir
+		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
+	endif ()
+
+	if(EXISTS "${PLUGINS_DIR}")
+		message(STATUS "using plugin directory: ${PLUGINS_DIR}")
+		set(NOMACS_FOUND true)
+		set(NOMACS_VARS_ALREADY_SET true)
+		add_subdirectory(${PLUGINS_DIR} "${CMAKE_CURRENT_BINARY_DIR}/plugins")
 	else()
+		message(STATUS "I failed to locate plugins in: ${PLUGINS_DIR}")
 		message(WARNING "plugins directory not found, not building plugins. You have to check out the nomacs-plugins git to the 'plugins' folder if you want to build them")
+		SET(ENABLE_PLUGINS OFF)
 	endif()
 endif()
 
 # status
 MESSAGE(STATUS "")
 MESSAGE(STATUS "----------------------------------------------------------------------------------")
-MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <http://www.nomacs.org>")
+MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <https://nomacs.org>")
 MESSAGE(STATUS "")
 
 option(ENABLE_READ_BUILD "Build nomacs for READ" OFF)
@@ -230,9 +247,28 @@
     MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... NO")
 ENDIF()
 
+IF(ENABLE_QUAZIP)
+    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. YES")
+ELSE()
+    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. NO")
+ENDIF()
+
+IF(USE_SYSTEM_QUAZIP)
+    MESSAGE(STATUS " nomacs will use system QuaZip ................................ YES")
+ELSE()
+    MESSAGE(STATUS " nomacs will use system QuaZip ................................ NO")
+ENDIF()
+
+IF(USE_SYSTEM_LIBQPSD)
+    MESSAGE(STATUS " nomacs will use system QPSD .................................. YES")
+ELSE()
+    MESSAGE(STATUS " nomacs will use system QPSD .................................. NO")
+ENDIF()
+
 IF(ENABLE_PLUGINS)
     MESSAGE(STATUS " nomacs will be compiled with plugin support .................. YES")
 ELSE()
     MESSAGE(STATUS " nomacs will be compiled with plugin support .................. NO")
 ENDIF()
+
 MESSAGE(STATUS "----------------------------------------------------------------------------------")

=== 3rdparty/libqpsd/CMakeLists.txt ===
project (qpsd)
cmake_minimum_required(VERSION 2.6)

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
	  
	IF(CMAKE_VERSION VERSION_GREATER 2.8.10)
		cmake_policy(SET CMP0020 NEW)	# qt warnings
	ENDIF()
  IF(CMAKE_VERSION VERSION_GREATER 2.8.12.9)
    cmake_policy(SET CMP0043 NEW)	# COMPILE_DEFINITIONS_<CONFIG> warnings
  ENDIF()
endif(COMMAND cmake_policy)

file(GLOB LIBQPSD_SOURCES "*.cpp")
file(GLOB LIBQPSD_HEADERS "*.h")

SET(CMAKE_DEBUG_POSTFIX "d")

add_library(${PROJECT_NAME} SHARED ${LIBQPSD_SOURCES} ${LIBQPSD_HEADERS})
target_link_libraries(${PROJECT_NAME} Qt5::Widgets Qt5::Gui)

set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/libs)
set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/libs)
set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_REALLYRELEASE ${CMAKE_CURRENT_BINARY_DIR}/libs)

add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E make_directory ${NOMACS_BUILD_DIRECTORY}/$<CONFIGURATION>/imageformats/)
add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:qpsd> ${NOMACS_BUILD_DIRECTORY}/$<CONFIGURATION>/imageformats/)

=== debian/changelog ===
nomacs (3.12.0+dfsg-3) unstable; urgency=medium

  * Switched to gbp
  * Switched from debhelper to debhelper-compat (= 12), no changes needed
  * Bumped Standards-Version to 4.5.0, no changes needed
  * Fixed FTBFS (Closes: #950310)
  * Bumped year in d/copyright

 -- Alf Gaida <agaida@siduction.org>  Sat, 08 Feb 2020 18:57:04 +0100

nomacs (3.12.0+dfsg-2) unstable; urgency=medium

  * Removed not needed patches
  * Fixed debian/nomacs.install and debian/nomacs-l10n.install

 -- Alf Gaida <agaida@siduction.org>  Tue, 13 Nov 2018 20:20:42 +0100

nomacs (3.12.0+dfsg-1) unstable; urgency=medium

  * Cherry-picked new upstream release 3.12.0.
  * Removed no longer needed patches
  * Bumped Standards to 4.2.1, no changes needed
  * Added missed files and license to d/copyright
  * Removed no longer needed replacement for lena.jpg
  * Removed README.source and source/lintian-overrides for lena.jpg
  * Removed no longer needed WTFPL2 from copyright
  * Patch QtApplicationName and Organiztion - we don't change
    config names and paths with every release.
  * Added upstream/metadata

 -- Alf Gaida <agaida@siduction.org>  Sat, 27 Oct 2018 22:55:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: nomacs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
+Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
https://github.com/nomacs/nomacs/releases .*/([\d\.]+)\.tar\.gz \
debian debian/repack.bash

## nomacs 3.14+dfsg

=== debian/changelog ===
nomacs (3.14+dfsg-0.1~mx19+1) mx; urgency=medium

  * New upstream release; build for MX Linux.
  * Build against libheif-dev and enable support in debian/rules.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 16 Mar 2020 19:34:36 -0700

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: nomacs
-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper (>= 11~),
                cmake,
                lcov,
                libexiv2-dev,
+               libheif-dev,
                liblcms2-dev,
                libopencv-dev,
                libqt5svg5-dev,
@@ -19,7 +21,7 @@
                qt5-qmake,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 4.5.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
 Homepage: http://www.nomacs.org
@@ -28,14 +30,15 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         qt5-image-formats-plugins
+         qt5-image-formats-plugins,
+         nomacs-l10n (= ${source:Version})
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)
 Replaces: libnomacscore3 (<< 3.6.1),
           libnomacsgui3 (<< 3.6.1),
-          libnomacsloader3 (<< 3.6.1)
-Recommends: nomacs-l10n (= ${source:Version})
+          libnomacsloader3 (<< 3.6.1),
+# Recommends: nomacs-l10n (= ${source:Version})
 Description: image viewer with capability of syncing multiple instances
  nomacs is a free image viewer for Windows and Linux systems, which is
  licensed under the GNU General Public License v3. nomacs is small, fast and

## nomacs 3.14.2%2Bdfsg

=== debian/changelog ===
nomacs (3.14.2+dfsg-0.1~mx19+1) mx; urgency=medium

  * New upstream release; build for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 05 May 2020 21:42:02 -0700

## nomacs 3.14.2+dfsg

=== debian/changelog ===
nomacs (3.14.2+dfsg-0.1~mx17+1) mx; urgency=medium

  * New upstream release; build for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 05 May 2020 21:42:02 -0700

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
 Build-Depends: debhelper (>= 11~),
                cmake,
                lcov,
+               libcurl4-gnutls-dev,
                libexiv2-dev,
                libheif-dev,
                liblcms2-dev,
@@ -16,6 +17,7 @@
                libqt5svg5-dev,
                libquazip5-dev,
                libraw-dev,
+               libssh-dev,
                libtiff5-dev,
                libwebp-dev,
                qt5-qmake,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -pthread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_HEIF=ON \
		-DENABLE_OPENCV=ON \
		-DENABLE_RAW=ON \
		-DENABLE_TIFF=ON \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_TRANSLATIONS=ON \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QUAZIP=ON \
		-DUSE_SYSTEM_QUAZIP=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_makeshlibs:
		#do nothing

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## nomacs 3.16.224

=== debian/changelog ===
nomacs (3.16.224-0mx21+1) mx; urgency=medium

  * Add heic & heif to desktop file
  * Add qt-heif-image-plugin Depends:

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 19 Apr 2021 16:43:09 -0400

nomacs (3.16.224-0mx21) mx; urgency=medium

  * New upstream release; build for MX-21

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 26 Mar 2021 21:05:16 -0400

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: nomacs
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
 XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
@@ -7,6 +7,7 @@
 Section: graphics
 Priority: optional
 Build-Depends: debhelper (>= 11~),
+               cdbs,
                cmake,
                lcov,
                libcurl4-gnutls-dev,
@@ -18,11 +19,13 @@
                libquazip5-dev,
                libraw-dev,
                libssh-dev,
-               libtiff5-dev,
+               libtiff-dev,
                libwebp-dev,
+               qt5-image-formats-plugins,
                qt5-qmake,
                qttools5-dev,
-               qttools5-dev-tools
+               qttools5-dev-tools,
+               libzip-dev
 Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
@@ -33,7 +36,8 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          qt5-image-formats-plugins,
-         nomacs-l10n (= ${source:Version})
+         nomacs-l10n (= ${source:Version}),
+         qt-heif-image-plugin
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -pthread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake --builddir=build

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	mkdir build
	cd build && cmake -DENABLE_HEIF=ON \
		-DENABLE_OPENCV=ON \
		-DENABLE_RAW=ON \
		-DENABLE_TIFF=ON \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_TRANSLATIONS=TRUE \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QUAZIP=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_SYSTEM_QUAZIP=ON ../ImageLounge .

override_dh_auto_clean:
	rm -rf build
	dh_auto_clean
	
override_dh_makeshlibs:
		#do nothing

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## nomacs 3.17.2206

=== ImageLounge/CMakeLists.txt ===

# check cmake requirements
cmake_minimum_required (VERSION 3.0)

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)

endif(COMMAND cmake_policy)

project(nomacs)

# needed for soname
set(NOMACS_VERSION_MAJOR 3)
set(NOMACS_VERSION_MINOR 17)
set(NOMACS_VERSION_PATCH 0)
set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})

if(CMAKE_CL_64)
	SET(NMC_ARCHITECTURE "x64")
else()
	SET(NMC_ARCHITECTURE "x86")
endif()

add_definitions(-DNOMACS_VERSION="${NOMACS_VERSION}")

set(BINARY_NAME ${CMAKE_PROJECT_NAME})
set(NOMACS_BUILD_DIRECTORY ${CMAKE_BINARY_DIR})

# if python is available, we can run additional build scripts (i.e. versioning)
find_package(Python QUIET)

# include macros needed
include("cmake/Utils.cmake")

set(QT5_MIN_VERSION 5.2.1)

# different compile options
option(ENABLE_OPENCV "Compile with Opencv (needed for RAW and TIFF)" ON)
option(ENABLE_RAW "Compile with raw images support (libraw)" ON)
option(ENABLE_TIFF "Compile with multi-layer tiff" ON)
option(ENABLE_QT_DEBUG "Disable Qt Debug Messages" ON)
option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
option(ENABLE_TRANSLATIONS "Compile Translations" ON)
option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)
option(ENABLE_HEIF "Compile nomacs with HEIF support" OFF)
option(ENABLE_AVIF "Compile nomacs with AVIF support" OFF)
option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
option(USE_SYSTEM_QUAZIP "QuaZip will not be compiled from source" ON) # ignored by MSVC

# Codecov
if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
    include("cmake/CodeCoverage.cmake")
    setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
endif()

if(APPLE)
	set(ENABLE_QUAZIP OFF)
	message(STATUS "QuaZip disabled - it's not supported on OSX")
endif()

# load paths from the user file if exists
if (EXISTS ${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
    include(${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)

elseif (MSVC)

    set(DEPENDENCY_PATH "" CACHE STRING "Select the path where all dependencies are built")

    # windows needs some hints here...
    if (NOT "${DEPENDENCY_PATH}" STREQUAL "")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/exiv2/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/opencv/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/quazip/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/libraw/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/imageformats/libheif")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/imageformats/libde265")
    endif()
endif()

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
elseif(NOT MSVC)
	message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
	# Codecov
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage")
endif()

# find Qt
NMC_FINDQT()

if (NOT ENABLE_QT_DEBUG)
	message (STATUS "disabling qt debug messages")
	add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Win.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Mac.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
endif()

file(GLOB NOMACS_EXE_SOURCES "src/*.cpp")
file(GLOB NOMACS_EXE_HEADERS "src/*.h")

# gui
file(GLOB GUI_SOURCES "src/DkGui/*.cpp")
file(GLOB GUI_HEADERS "src/DkGui/*.h")

# core
file(GLOB CORE_SOURCES "src/DkCore/*.cpp")
file(GLOB CORE_HEADERS "src/DkCore/*.h")

# gather information for building
include_directories (
	${EXIV2_INCLUDE_DIRS}
	${LIBRAW_INCLUDE_DIRECTORY}
	${CMAKE_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkGui
	${TIFF_INCLUDE_DIR}
	${TIFF_CONFIG_DIR}
	${QUAZIP_INCLUDE_DIR}
	${QUAZIP_ZLIB_INCLUDE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libqpsd	# needed for linux psd hack
	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/drif
)

if (APPLE) # todo: somehow add this to Mac.cmake or MacBuildTarget.cmake
	SET (NOMACS_SOURCES ${NOMACS_SOURCES} macosx/nomacs.icns)
endif (APPLE)

IF(NOT ENABLE_PLUGINS)
	LIST(REMOVE_ITEM GUI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.cpp)
	LIST(REMOVE_ITEM GUI_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.h)
ENDIF(NOT ENABLE_PLUGINS)

# create version file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore/DkVersion.h.in ${CMAKE_CURRENT_BINARY_DIR}/DkVersion.h)

set(NOMACS_FORMS src/nomacs.ui)
set(NOMACS_RESOURCES src/nomacs.qrc)

file(GLOB NOMACS_TRANSLATIONS "translations/*.ts")

QT5_ADD_RESOURCES(NOMACS_RCC ${NOMACS_RESOURCES})

if (${ENABLE_TRANSLATIONS})
	QT5_ADD_TRANSLATION(NOMACS_QM ${NOMACS_TRANSLATIONS})
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MacBuildTarget.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
endif()

# add build incrementer command if requested
if (ENABLE_INCREMENTER AND Python_FOUND)

    add_custom_command(
        TARGET ${DLL_CORE_NAME} PRE_BUILD 
        COMMAND ${Python_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionincrement.py 
        ${NOMACS_VERSION})

    message(STATUS "build incrementer enabled...")

endif()

if (Python_FOUND)
    
    add_custom_command(
        TARGET ${DLL_CORE_NAME} PRE_BUILD 
        COMMAND ${Python_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
        ${CMAKE_BINARY_DIR}/DkVersion.h)

    # I am having issues with the PRE_BUILD above
    # if version increment is off, we just need to run the update once (for version won't change)
    # so let's do that:
    execute_process(COMMAND ${Python_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
            ${CMAKE_BINARY_DIR}/DkVersion.h)

else()
    message(WARNING "Python not found: the version number will be incorrect!")
endif()


NMC_INSTALL()

NMC_COPY_FILES()

#debug for printing out all variables
# get_cmake_property(_variableNames VARIABLES)
# foreach (_variableName ${_variableNames})
#     message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()

if(ENABLE_PLUGINS)

	if (NOT EXISTS ${PLUGINS_DIR})
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
	else ()
		message(STATUS "${PLUGINS_DIR} is defined")
	endif()

	if (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
	elseif (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
		# set the snapcraft/flathub dir
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
	endif ()

	if(EXISTS "${PLUGINS_DIR}/CMakeLists.txt")
		message(STATUS "using plugin directory: ${PLUGINS_DIR}")
		set(NOMACS_FOUND true)
		set(NOMACS_VARS_ALREADY_SET true)
		add_subdirectory(${PLUGINS_DIR} "${CMAKE_CURRENT_BINARY_DIR}/plugins")
	else()
		message(STATUS "I failed to locate plugins in: ${PLUGINS_DIR}")
		message(WARNING "plugins directory not found, not building plugins. You have to check out the nomacs-plugins git to the 'plugins' folder if you want to build them")
		SET(ENABLE_PLUGINS OFF)
	endif()
endif()

# get rid of VSCode warning (when using MSBuild)
# see: https://stackoverflow.com/questions/36451368/get-rid-of-cmake-warning-manually-specified-variables-were-not-used-by-the-proj/36452112
set(ignoreMe "${CMAKE_EXPORT_COMPILE_COMMANDS}")

# status
MESSAGE(STATUS "")
MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <https://nomacs.org>")
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_VERSION OUTPUT_VARIABLE qt_version)
message(STATUS " Qt version: ${qt_version}")


IF(OpenCV_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. NO")
ENDIF()

IF(LIBRAW_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. NO")
ENDIF()

IF(ENABLE_TIFF)
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... NO")
ENDIF()

IF(ENABLE_PLUGINS)
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. NO")
ENDIF()

IF(libheif_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... NO")
ENDIF()

IF(ENABLE_TRANSLATIONS)
    MESSAGE(STATUS " nomacs will be compiled with Translations .................... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with Translations .................... NO")
ENDIF()

IF(ENABLE_QUAZIP)
    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. NO")
ENDIF()

MESSAGE(STATUS "----------------------------------------------------------------------------------")

=== debian/changelog ===
nomacs (3.17.2206-0.1~mx21+1) mx; urgency=medium

  * New upstream release.
  * Comment out dh_makeshlibs override in d/rules.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 28 Jul 2021 13:31:29 -0700

## nomacs 3.17.2206%2Bgit20230315

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: nomacs
-Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+# XSBC-Original-Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
 XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper (>= 11~),
-               cdbs,
-               cmake,
+Build-Depends: cmake,
+               debhelper (>= 11~),
                lcov,
                libcurl4-gnutls-dev,
                libexiv2-dev,
@@ -21,11 +21,11 @@
                libssh-dev,
                libtiff-dev,
                libwebp-dev,
+               libzip-dev,
                qt5-image-formats-plugins,
-               qt5-qmake,
+#               qt5-qmake,
                qttools5-dev,
-               qttools5-dev-tools,
-               libzip-dev
+               qttools5-dev-tools
 Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
@@ -33,18 +33,17 @@
 
 Package: nomacs
 Architecture: any
-Depends: ${shlibs:Depends},
+Depends: nomacs-l10n (= ${source:Version}),
+         qt-heif-image-plugin,
+         qt5-image-formats-plugins,
          ${misc:Depends},
-         qt5-image-formats-plugins,
-         nomacs-l10n (= ${source:Version}),
-         qt-heif-image-plugin
+         ${shlibs:Depends}
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)
 Replaces: libnomacscore3 (<< 3.6.1),
           libnomacsgui3 (<< 3.6.1),
-          libnomacsloader3 (<< 3.6.1),
-# Recommends: nomacs-l10n (= ${source:Version})
+          libnomacsloader3 (<< 3.6.1)
 Description: image viewer with capability of syncing multiple instances
  nomacs is a free image viewer for Windows and Linux systems, which is
  licensed under the GNU General Public License v3. nomacs is small, fast and

## nomacs 3.17.2206+dfsg

=== debian/changelog ===
nomacs (3.17.2206+dfsg-2build1) lunar; urgency=medium

  * No-change rebuild against libtiff6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 05 Feb 2023 04:27:20 +0000

nomacs (3.17.2206+dfsg-2) unstable; urgency=medium

  * Update Homepage (Closes: #974618).
  * Use libtiff-dev instead of libtiff5-dev as Build-Depends (Closes: #998316)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 12 Jan 2023 11:58:31 +0800

nomacs (3.17.2206+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #974617).
  * Bump Standards-Version to 4.6.2:
    * Add "Rules-Requires-Root: no" in d/control.
  * Bump compat to 13:
    * Remove unnecessary --fail-missing in d/rules.
    * Remove unnecessary -Wl,--as-needed in d/rules.
  * Use Files-Excluded to generate DFSG tarball.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 05 Jan 2023 23:51:37 +0800

=== debian/control ===
--- 
+++ 
@@ -1,49 +1,43 @@
 Source: nomacs
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-# XSBC-Original-Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: cmake,
-               debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                lcov,
-               libcurl4-gnutls-dev,
                libexiv2-dev,
-               libheif-dev,
                liblcms2-dev,
                libopencv-dev,
                libqt5svg5-dev,
                libquazip5-dev,
                libraw-dev,
-               libssh-dev,
                libtiff-dev,
                libwebp-dev,
-               libzip-dev,
-               qt5-image-formats-plugins,
-#               qt5-qmake,
+               qt5-qmake,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 4.2.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
-Homepage: http://www.nomacs.org
+Homepage: https://nomacs.org/
+Rules-Requires-Root: no
 
 Package: nomacs
 Architecture: any
-Depends: nomacs-l10n (= ${source:Version}),
-         qt-heif-image-plugin,
-         qt5-image-formats-plugins,
+Depends: ${shlibs:Depends},
          ${misc:Depends},
-         ${shlibs:Depends}
+         qt5-image-formats-plugins
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)
 Replaces: libnomacscore3 (<< 3.6.1),
           libnomacsgui3 (<< 3.6.1),
           libnomacsloader3 (<< 3.6.1)
+Recommends: nomacs-l10n (= ${source:Version})
 Description: image viewer with capability of syncing multiple instances
  nomacs is a free image viewer for Windows and Linux systems, which is
  licensed under the GNU General Public License v3. nomacs is small, fast and

## nomacs 3.17.2206+git20230315

=== debian/changelog ===
nomacs (3.17.2206+git20230315-0mx23) mx; urgency=medium

  * Latest git version build for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 11 Apr 2023 13:40:46 -0400
